import { PropsWithChildren } from 'react'

export const noop = () => {}

export function wrapProps(props: PropsWithChildren<CustomPropsType>) {
  let {
    adpId,
    autoplay,
    loop = true,
    muted = false,
    showMusk,
    zIndex = 1,
    openEmbeddedMiniProgram = noop,
    onPlay = noop,
    onPause = noop,
    onEnded = noop,
    onTimeUpdate = noop,
    onStop = noop,
    onError = noop,
    onLoad = noop,
    onView = noop,
    onClick = noop,
    onClose = noop
  } = props

  if (typeof zIndex !== 'number')
    zIndex = 1

  return {
    adpId,
    autoplay,
    loop,
    muted,
    showMusk,
    zIndex,
    openEmbeddedMiniProgram,
    onPlay,
    onPause,
    onEnded,
    onTimeUpdate,
    onStop,
    onError,
    onLoad,
    onView,
    onClick,
    onClose
  }
}

export function generateUUID () {
  let d = new Date().getTime();
  let uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
      let r = (d + Math.random() * 16) % 16 | 0;
      d = Math.floor(d / 16);
      return (c === 'x' ? r : (r & 0x7) | 0x8).toString(16);
  });
  return uuid;
}